<template>
  <bh-topics-filter-ui
    :topics="topics"
    :selected="selected"
    @changed="onChanged"
  />
</template>

<script>
export default {
  name: 'BhTopicsFilter',
  // fetchOnServer: process.env.NODE_ENV !== 'development',
  data: () => ({
    topicList: [],
  }),
  async fetch() {
    try {
      this.topicList = await this.$dataService.getTopics();
    } catch (error) {
      const query = { mid: 'topics.fetch.error' };

      if (process.server) {
        this.$nuxt.context.redirect('/server-error', query);
      }
      if (process.client) {
        this.$router.push({ path: '/server-error', query });
      }
    }
  },
  computed: {
    active() {
      return this.$store.getters['filters/getActiveTopics'];
    },
    topics() {
      return this.topicList.map((topic) => ({
        ...topic,
        disabled: !this.active.has(topic.code),
      }));
    },
    selected() {
      const selected = this.$store.getters['filters/getSelectedTopics'];
      return this.topics.filter((topic) => selected.includes(topic.code));
    },
  },
  methods: {
    onChanged(selectedTopics) {
      const selected = selectedTopics.map(({ code }) => code);
      this.$store.dispatch('filters/setSelectedTopics', selected);
      this.$emit('changed');
    },
  },
};
</script>
